<html>
    <head>
        <title>sauvegarde et backup externalisée en ligne sur internet, archivage de mails</title>
        <meta http-equiv="Content-Language" content="fr" />
        <meta http-equiv="Content-Script-Type" content="text/javascript" />
        <meta http-equiv="Content-Style-Type" content="text/css" />
        <script type="text/javascript" src="js/prototype.js"></script>
        <script type="text/javascript" src="js/ext-prototype-adapter.js"></script>
        <script type="text/javascript" src="js/ext-all-debug.js"></script>
        <script type="text/javascript" src="js/locales/lang.fr.js"></script>
        <link rel="stylesheet" media="screen" href="css/ext-all.css" />
        <link rel="stylesheet" media="screen" href="css/screen.css" />
        <link rel="stylesheet" media="screen" href="css/styles.css" />
        <link rel="shortcut icon" type="image/x-icon" href="images/favicon.ico" />
        <script type="text/javascript">
            
            Ext.BLANK_IMAGE_URL = 'images/default/s.gif';
            
            Ext.MessageBox.minWidth = 300;
            
            function loadPage(page, initFunc){
                new Ajax.Request('/' + page, {
                    'onSuccess': function(xhr, json){
                        $('contenu').innerHTML = xhr.responseText;
                        initFunc();
                    }
                    /*,
                     'onException':function(xhr,data) {
                     alert('Erreur, serveur indisponible');
                     }*/
                });
            }
            
            function loadTree(){
            
                Ext.QuickTips.init();
                
                var treeLoader = new Ext.tree.TreeLoader({
                    url: '/getNodeChildren'
                });
                //treeLoader.on('load', this.initTreeNodeEvents, this);
                
                tree = new Ext.tree.TreePanel({
                    title: "sauvegarde",
                    el: 'tree-div',
                    animate: false,
                    frame: true,
                    loader: treeLoader,
                    enableDrag: true,
                    enableDrop: false,
                    enableDD: true,
                    ddGroup: 'backup_item',
                    autoScroll: true,
                    containerScroll: true,
                    rootVisible: false,
                    root: new Ext.tree.AsyncTreeNode({
                        id: '__root__'
                    })
                    ,header: true
                    /*,buttons: [
                        {
                            text: 'Ouvrir tout'
                            ,handler: function( button ){
                                Ext.each(this.include, function(node){
                                    console.log(tree.getNodeById(node.id),node.id);
                                    tree.getNodeById(node.id).getPath();
                                });
                            }
                            , scope: this
                        }
                    ]*/
                });
                
                new Ext.tree.TreeSorter(tree, {
                    folderSort: true,
                    dir: 'asc'
                });
                
                tree.render();
                tree.root.expand();
                this.include = new Array();
                this.exclude = new Array();
                
                var canvasInclude = new Ext.form.FieldSet({
                    title: 'Dossiers à sauvegarder',
                    enableDrop: 'true',
                    height: '100',
                    id: "includeList",
                    items: {
                        id: 'includeListContent',
                        html: 'Deplacez ici les dossiers à sauvegarder'
                    }
                });
                
                var canvasExclude = new Ext.form.FieldSet({
                    title: 'Dossiers à exclure',
                    enableDrop: 'true',
                    height: '100',
                    id: "excludeList",
                    items: {
                        id: 'excludeListContent',
                        html: 'Deplacez ici les dossiers à exclure'
                    }
                });
                
                var canvasExcludePattern = new Ext.form.FieldSet({
                    title: 'Type de fichiers a exclure',
                    height: '100',
                    id: "excludePatternList",
                    items: {
                        xtype: 'textarea',
                        fieldLabel: 'Un par ligne',
                        id: 'excludePattern',
                        value: $('__excludePattern').value,
                        height: "60",
                        anchor: '100%',
                        listeners: {
                           'change' : {
                                fn : function(el, value){ 
                                        $('__excludePattern').value = value;
                                        this.saveConfig();
                                }, 
                                scope: this 
                            }
                        }
                    }
                });

                var canvasTime = new Ext.form.FieldSet({
                    title: 'Programmation de la sauvegarde',
                    height: '100',
                    id: "backupTimeList",
                    items: [/*{
                        fieldLabel: 'Heure de la sauvegarde',
                        xtype: 'timefield',
                        format: 'H:i',
                        increment: 60,
                        listeners: {
                            'select': {
                                fn: function(el, value){
                                    $('__hourBackup').value = value.data.text;
                                    this.saveConfig();
                                },
                                scope: this
                            }
                        },
                        width: 50,
                        id: 'BackupHTime',
                        value: $('__hourBackup').value
                    },*/ {
                        fieldLabel: 'Heure de la sauvegarde',
                        xtype: 'timefield',
                        format: 'H:i',
                        increment: 1,
                        listeners: {
                            'select': {
                                fn: function(el, value){
                                    var hour = Date.parseDate(value.data.text, 'H:i');
                                    $('__hourBackup').value = hour.getHours();
                                    $('__minBackup').value = hour.getMinutes();
                                    this.saveConfig();
                                },
                                scope: this
                            }
                        },
                        value: $('__hourBackup').value +':'+$('__minBackup').value,
                        width: 70,
                        id: 'BackupMTime'
                    }]
                });
                
                var form = new Ext.form.FormPanel({
                    title: "Parametres",
                    frame: true,
                    renderTo: 'param',
                    labelAlign: 'top',
                    items: [canvasInclude, canvasExclude, canvasExcludePattern, canvasTime],
                    buttons: [{
                        text: 'Lancer la sauvegarde',
                        handler: this.runBackup,
                        scope: this
                    
                    }]
                });
                
                this.include = Ext.util.JSON.decode($('__includeFiles').innerHTML);
                this.updateBackupList();
                
                var dropZoneBackup = new Ext.dd.DropTarget(canvasInclude.getEl(), {
                    ddGroup: 'backup_item',
                    
                    notifyDrop: function(source, event, obj){
                        addBackupItem(obj.node);
                        return true;
                    }
                });
                this.exclude = Ext.util.JSON.decode($('__excludeFiles').innerHTML);
                
                this.updateExcludeList();
                new Ext.dd.DropTarget(canvasExclude.getEl(), {
                    ddGroup: 'backup_item',
                    
                    notifyDrop: function(source, event, obj){
                        addExcludeItem(obj.node);
                        return true;
                    }
                });
            }
            
            function loadRestoreTree(){
                var treeLoaderBackup = new Ext.tree.TreeLoader({
                    url: '/getBackupNodeChildren'
                });
                
                treeLoaderBackup.on('beforeload', function(treeLoader, node){
                    this.baseParams.bid = node.attributes.bid;
                    this.baseParams.path = node.attributes.path;
                }, treeLoaderBackup);
                
                this.treeBackup = new Ext.tree.TreePanel({
                    title: lang.tree.restore,
                    el: 'tree-div',
                    animate: false,
                    loader: treeLoaderBackup,
                    enableDrag: true,
                    enableDrop: false,
                    enableDD: true,
                    ddGroup: 'restore_item',
                    frame: true,
                    autoScroll: true,
                    containerScroll: true,
                    rootVisible: false,
                    root: new Ext.tree.AsyncTreeNode({
                        id: '__bid_root__',
                        bid: '',
                        path: ''
                    })
                });
                this.treeBackup.root.expand();
                
                /*new Ext.tree.TreeSorter(this.treeBackup, {
                 folderSort: true,
                 dir: 'desc'
                 });*/
                this.treeBackup.root.expand();
                this.treeBackup.render();
                this.rincluded = new Array();
                
                
                canvas = new Ext.form.FieldSet({
                    title: 'Dossiers à restaurer',
                    enableDrop: 'true',
                    height: '100',
                    id: "restoreFilesList",
                    items: {
                        id: 'restoreFilesListContent',
                        html: 'Deplacez ici les dossiers à restaurer'
                    }
                });
                var form = new Ext.form.FormPanel({
                    title: "Parametres",
                    renderTo: 'param',
                    labelAlign: 'top',
                    frame: true,
                    items: [canvas, {
                        xtype: 'hidden',
                        id: 'restorebid'
                    }, {
                        xtype: 'textfield',
                        fieldLabel: 'Date de la restauration',
                        id: 'restore_date',
                        readOnly: true,
                        anchor: '100%'
                    }, {
                        xtype: 'textfield',
                        fieldLabel: 'Chemin de restauration',
                        id: 'destpath',
                        value: $('__destpath') ? $('__destpath').value : '',
                        anchor: '100%'
                    }, {
                        xtype: 'checkbox',
                        fieldLabel: 'Restaurer au même endroit ?',
                        id: 'same_destpath',
                        listeners: {
                            'check': {
                                fn: function(el, checked){
                                    if (checked) {
                                        Ext.get('destpath').oldValue = Ext.get('destpath').dom.value;
                                        Ext.get('destpath').dom.value = 'INPLACE';
                                        Ext.get('destpath').dom.disabled = true;
                                    }
                                    else {
                                        Ext.get('destpath').dom.value = Ext.get('destpath').oldValue;
                                        Ext.get('destpath').dom.disabled = false;
                                    }
                                },
                                scope: this
                            }
                        }
                    }],
                    buttons: [{
                        text: 'Lancer la restauration',
                        handler: this.restore,
                        scope: this
                    }]
                
                });
                
                var dropZone = new Ext.dd.DropTarget(canvas.getEl(), {
                    ddGroup: 'restore_item',
                    
                    notifyDrop: function(source, event, obj){
                        clear = false;
                        if ($('restorebid').value != '') {
                            if ($('restorebid').value != obj.node.attributes.bid) {
                                Ext.MessageBox.alert('Attention', 'Vous ne pouvez pas mélanger les backups\nVotre sélection va être réinitialisée');
                                clear = true;//this.rincluded.clear();
                            }
                        }
                        $('restorebid').value = obj.node.attributes.bid;
                        $('restore_date').value = obj.node.attributes.date_backup;
                        addRestoreItem(obj.node, clear);
                        return true;
                    }
                });
                
            }
            
            function initializeDropZone(g){
                g.dropZone = new Ext.dd.DropZone(g, {
                
                    //      If the mouse is over a target node, return that node. This is
                    //      provided as the "target" parameter in all "onNodeXXXX" node event handling functions
                    getTargetFromEvent: function(e){
                        return e.getTarget('.hospital-target');
                    },
                    
                    //      On entry into a target node, highlight that node.
                    onNodeEnter: function(target, dd, e, data){
                        Ext.fly(target).addClass('hospital-target-hover');
                    },
                    
                    //      On exit from a target node, unhighlight that node.
                    onNodeOut: function(target, dd, e, data){
                        Ext.fly(target).removeClass('hospital-target-hover');
                    },
                    
                    //      While over a target node, return the default drop allowed class which
                    //      places a "tick" icon into the drag proxy.
                    onNodeOver: function(target, dd, e, data){
                        return Ext.dd.DropZone.prototype.dropAllowed;
                    },
                    
                    //      On node drop, we can interrogate the target node to find the underlying
                    //      application object that is the real target of the dragged data.
                    //      In this case, it is a Record in the GridPanel's Store.
                    //      We can use the data set up by the DragZone's getDragData method to read
                    //      any data we decided to attach.
                    onNodeDrop: function(target, dd, e, data){
                        var rowIndex = g.getView().findRowIndex(target);
                        var h = g.getStore().getAt(rowIndex);
                        Ext.Msg.alert('Drop gesture', 'Dropped patient ' + data.patientData.name +
                        ' on hospital ' +
                        h.data.name);
                        return true;
                    }
                });
            }
            
            function loadRegister(){
                this.registerForm = new Ext.FormPanel({
                    title: "Parametres",
                    renderTo: 'registerform',
                    url: 'register',
                    height: 200,
                    width: 600,
                    labelWidth: 240,
                    frame: true,
                    items: [{
                        xtype: 'textfield',
                        fieldLabel: 'Nom de la machine',
                        id: 'user'
                        ,width: 250
                    }, {
                        xtype: 'textfield',
                        fieldLabel: 'Clef de contrat',
                        id: 'key'
                        ,width: 250
                    }, {
                        xtype: 'textfield',
                        fieldLabel: 'Serveur(s) de sauvegarde',
                        id: 'server_hostname',
                        value: '$kserver_hostname'
                        ,width: 300
                    }],
                    buttons: [{
                        text: 'Enregistrer cette machine',
                        handler: this.registerSubmit,
                        scope: this
                    }]
                
                });
                this.registerForm.render();
            }
            
            function registerSubmit(){
                this.registerForm.form.submit({
                    url: this.registerForm.url,
                    success: function(button, response){
                        if (response.result.status == 'ok') {
                            this.loadPage('accueil', this.loadRegister);
                        }
                    },
                    failure: function(button, response){
                        if (response.result) {
                            Ext.MessageBox.alert( lang.register.error, response.result.params.msg);
                        }
                    },
                    scope: this
                })
            };
            
            
            
            function addBackupItem(node){
                this.include.push({
                    id: node.id,
                    path: node.id
                });
                this.saveConfig();
            }
            
            function addExcludeItem(node){
                this.exclude.push({
                    id: node.id,
                    path: node.id
                });
                this.saveConfig();
            }
            
            function removeBackupItem(nid){
            
                Ext.each(this.include, function(node){
                    if (node) {
                        if (node.id == unescape(nid)) 
                            this.include.remove(node);
                    }
                }, this);
                this.saveConfig();
            }
            
            function removeExcludeItem(nid){
            
                Ext.each(this.exclude, function(node){
                    if (node) {
                        if (node.id == unescape(nid)) 
                            this.exclude.remove(node);
                    }
                }, this);
                this.saveConfig();
            }
            
            function removeRestoreItem(nid, el){
            
                Ext.each(this.rincluded, function(node){
                    if (node) {
                        if (node.id == unescape(nid)) 
                            this.rincluded.remove(node);
                    }
                }, this);
                Ext.fly(el).dom.up().remove();
            }
            
            
            function updateBackupList(){
                var t = new Ext.Template('<div name="{id}" class="folderlist">', '<a href="#" onclick="removeBackupItem(\'{id}\');return false;"><img src="images/delete.gif"/></a>', '<img class="icon" src="images/default/tree/folder.gif"/>', '<span>{value}</span>', '</div>');
                s = "";
                $('includeListContent').innerHTML = '';
                Ext.each(this.include, function(node){
                    s = s + t.append('includeListContent', {
                        id: escape(node.id),
                        value: node.path
                    });
                });
            }
            
            function updateExcludeList(){
                var t = new Ext.Template('<div name="{id}" class="folderlist">', '<a href="#" onclick="removeExcludeItem(\'{id}\');return false;"><img src="images/delete.gif"/></a>', '<img class="icon" src="images/default/tree/folder.gif"/>', '<span>{value}</span>', '</div>');
                s = "";
                $('excludeListContent').innerHTML = '';
                Ext.each(this.exclude, function(node){
                    s = s + t.append('excludeListContent', {
                        id: escape(node.id),
                        value: node.path
                    });
                });
            }
            
            function addRestoreItem(node, clear){
                if (clear) 
                    this.rincluded.clear();
                if (this.rincluded.indexOf(node) < 0) {
                    this.rincluded.push(node);
                    
                    var t = new Ext.Template('<div name="{id}" class="folderlist">', '<a href="#" onclick="removeRestoreItem(\'{id}\', this);return false;"><img src="images/delete.gif"/></a>', '<img class="icon" src="images/default/tree/folder.gif"/>', '<span>{value}</span>', '</div>');
                    s = "";
                    $('restoreFilesListContent').innerHTML = '';
                    Ext.each(this.rincluded, function(node){
                        s = s + t.append('restoreFilesListContent', {
                            id: escape(node.id),
                            value: node.attributes.path
                        });
                    });
                }
            }
            
            function getActus() {
                
                Ext.Ajax.request({
                    url: '/getRSS',
                    method: 'GET',
                    success: function(xhr, json) {
                        resp = Ext.util.JSON.decode(xhr.responseText);
                        listActus(resp.entries);
                    }
                });
            }
            
            function listActus(actus) {
                Ext.get('liste-actualites').update('');
                Ext.each(actus, function(actu) {
                    renderActu(actu);
                });
                if(actus.length == 0) {
                    Ext.get('liste-actualites').update('Aucune actualité.');
                }
            }
            
            function renderActu(actu) {
                var t = new Ext.Template('<li><h1><a onclick="window.open(this.href); return false;" href="{link}">{title}</a></h1><p>{content}</p></li>');
                t.append('liste-actualites', {
                    link: actu.link,
                    title: actu.title,
                    content: actu.content ? actu.content[0].value : actu.summary
                } );
            }
            
            function saveConfig(){
                var _included = this.include.map(function(el, i, res){
                    return el.id;
                });
                
                var _excluded = this.exclude.map(function(el, i, res){
                    return el.id;
                });
                
                Ext.Ajax.request({
                    url: '/saveConfig',
                    method: 'POST',
                    params: {
                        hour: '12',
                        min: '30',
                        include: Ext.util.JSON.encode(_included),
                        exclude: Ext.util.JSON.encode(_excluded),
                        excludepattern: $('__excludePattern').value,
                        hour: $('__hourBackup').value,
                        min: $('__minBackup').value
                    },
                    success: this._saveConfigSuccess,
                    failure: this._saveConfigError,
                    scope: this
                });
            };
            
            function _saveConfigError(xhr, json){
                Ext.MessageBox.alert('erreur', xhr.responseText);
            };
            
            function _saveConfigSuccess(xhr, json){
                resp = Ext.util.JSON.decode(xhr.responseText);
                this.include = resp.include;
                this.exclude = resp.exclude;
                $('excludePattern').value = resp.excludepattern;
                this.updateBackupList();
                this.updateExcludeList();
            };
            
            
            function getCR(){
            
                if (Ext.isWindows) {
                    return "\r\n";
                }
                else 
                    if (Ext.isMac) {
                        return "\r";
                    }
                    else {
                        return "\n";
                    }
            };
            
            function runBackup(){
                src = "runBackup";
                showConsole(src);
            };
            
            function restore(e, domEl, params){
            
                destpath = $('destpath').value;
                bid = $('restorebid').value;
                rpath = [];
                Ext.each(this.rincluded, function(node){
                    rpath.push(node.attributes.path);
                }, this);
                
                params = {
                    'destpath': destpath,
                    'bid': bid,
                    'rpath': rpath
                };
                //console.log(params);
                src = "runRestore?params=" + escape(Ext.util.JSON.encode(params));
                showConsole(src);
                
            };
            function showConsole(src){
                var cwin = new Ext.Window({
                    title: 'Console',
                    html: '<h1>Console d\'execution</h1><iframe width="550" height="350" src="' + src + '">Vous pouvez fermer cette console. Ceci n\'interrompt pas le déroulement des opérations',
                    height: '420',
                    width: '570'
                });
                cwin.show();
            };
            
            Ext.onReady(function(){
                getActus();
                loadPage('accueil', this.loadRegister);
            });
        </script>
    </head>
    <body>
        <div id="conteneur">
            <div id="droite">
                <div id="droiteheader">
                    <img src="images/haut-droit.png" style="display:block;"/>
                    <br/>
                    <br/>
                    <br/>
                    <br/>
                                        <img src="images/boite-tips-top.jpg" style="display:block;cursor:pointer" onclick="getActus()" />
                                        <div class="liste-actualites">
                                                <ul id="liste-actualites">
                                                </ul>
                                        </div>
                                        <img src="images/boite-tips-bottom.jpg" style="display:block;"/>
                                        <img src="images/boite-contact-top.jpg" style="display:block;"/>
                                        <div class="coordonnees1">
                                                <p class="coordonnees">
                                                <span style="text-align:center"><img src="images/tel.png" /></span><br/><br/>
                    </div>
                                        <img src="images/boite-contact-bottom.jpg" style="display:block;"/>
                    <div style="clear:both;">
                        &nbsp;
                    </div>
                </div>
            </div>
            <div id="gauche">
                <div id="header">
                    <a href="/" title="sauvegarde en ligne"><img src="images/logo.png" alt="sauvegarde en ligne, serveurs de sauvegarde" style="float:left;display:block;"/></a>
                </div>
                <div id="menu1">
                    <!-- on descent d'un niveau -->
                    <ul class="menu_niv1" id="menu">
                        <li class="menu_niv1_parent"><a href="javascript:loadPage('accueil',this.loadRegister)"><span class="menu_niv1"><img src="images/menu-accueil.png" />Accueil</span></a>
                            <li class="menu_niv1_parent">
                                <a href="javascript:loadPage('backup_config',this.loadTree)"><span class="menu_niv1"><img src="images/menu-sauve.png" />Sauvegarde</span></a>
                            <li class="menu_niv1_parent">
                                <a href="javascript:loadPage('restore_config',this.loadRestoreTree)"><span class="menu_niv1"><img src="images/menu-restore.png" />Restauration</span></a>
                            <li class="menu_niv1_parent">
                                <a href="javascript:showConsole('runCalc');"><span class="menu_niv1"><img src="images/menu-calcul.png" />Calcul</span></a>
                            <li class="menu_niv1_parent">
                                <a href="javascript:showConsole('runSync');"><span class="menu_niv1"><img src="images/menu-synchro.png" />Synchro</span></a>

                   </ul>
                 </div>
                 <div id="centrehome">
                     <div class="prop"></div>
                     <div id="contenu" style="height:100%">
                     </div>
                                <!-- contenu --><div class="clear" />
                 </div>
                        </div>
                            </body>
                        </html>
